# -*- coding: utf-8 -*-
from PIL import Image
import cv2
import numpy as np
import random
import time
import sys
import winxpgui
from ctypes import *
import win32gui
import win32ui
import win32con
user32 = windll.user32

windowTopLeft = [0,0]
windowScale = 1 # 1280x720に対する比率
screenWidth = 1920
screenHeight = 1080
screenScale = 1 # Windowsの文字サイズ拡大機能使用時の比率

def setScreenSize(width, height, scale=1):
	global screenWidth, screenHeight, screenScale
	screenWidth = width
	screenHeight = height
	screenScale = scale
	
def compareImg(patimgNp,npimg):
	w, h = patimgNp.shape[::-1]
	method = cv2.TM_CCOEFF_NORMED
	res = cv2.matchTemplate(npimg,patimgNp,method)
	min_val, max_val, min_loc, max_loc = cv2.minMaxLoc(res)
	
	top_left = max_loc
	bottom_right = (top_left[0] + w, top_left[1] + h)

	cv2.rectangle(npimg,top_left, bottom_right, 255, 2)
	#cv2.imwrite("rect.png",npimg)
	print max_val
	if max_val > 0.7:
		return (top_left[0] + w/2, top_left[1] + h/2)

def screenshot():
	""" スクリーンショット撮ってそれを(Pillow.Imageで)返す """
	window = win32gui.GetDesktopWindow()
	window_dc = win32ui.CreateDCFromHandle(win32gui.GetWindowDC(window))
	compatible_dc = window_dc.CreateCompatibleDC()
	width = screenWidth
	height = screenHeight
	bmp = win32ui.CreateBitmap()
	bmp.CreateCompatibleBitmap(window_dc, width, height)
	compatible_dc.SelectObject(bmp)
	compatible_dc.BitBlt((0, 0), (width, height), window_dc, (0, 0), win32con.SRCCOPY)
	img = Image.frombuffer('RGB', (width, height), bmp.GetBitmapBits(True), 'raw', 'RGBX', 0, 1)
	
	win32gui.DeleteObject(bmp.GetHandle())
	compatible_dc.DeleteDC()
	window_dc.DeleteDC()
	win32gui.ReleaseDC(window, win32gui.GetWindowDC(window)) 
	return img
	
def chkimg(imgname, hwnd, scale = 1):
	global windowTopLeft,windowScale
	scale = screenScale
	
	patimg = cv2.imread(imgname,0)

	rect = winxpgui.GetWindowRect(hwnd)
	size = winxpgui.GetClientRect(hwnd)
	cap = np.array(rect,dtype=int)*scale
	cap = np.array(cap,dtype=int)
	windowTopLeft = [rect[0], rect[1]]
	img = np.asarray(screenshot())
	#baseimg = img[cap[1]:cap[3],cap[0]:cap[2]]
	margin = np.array([30,-7.5,7.5,-7.5],dtype=float)*scale
	margin = np.array(margin,dtype=int)
	baseimg = img[cap[1]+margin[0]:cap[3]+margin[1],cap[0]+margin[2]:cap[2]+margin[3]]
	windowScale = len(baseimg)/720.0
	cv2.imwrite("cap.png",baseimg)
		
	npimg = np.asarray(baseimg)
	capimg = cv2.cvtColor(npimg,cv2.COLOR_BGR2GRAY)
	
	ignore = ['img\\ps.png', 'img\\options.png']
	if imgname in ignore:
		patimg = cv2.resize(patimg,(int(np.ceil(len(patimg[0])*scale/1.5)),int(np.ceil(len(patimg)*scale/1.5))))
	else:
		patimg = cv2.resize(patimg,(int(len(patimg[0])*windowScale),int(len(patimg)*windowScale)))
	cv2.imwrite(imgname[4:],patimg)
	retXY = compareImg(patimg,capimg)
	if(retXY != None):
		bool = True
	else:
		bool = False

	return(bool, retXY)

def click(x,y,wait = 0.2):
	xPos = windowTopLeft[0]+int((x+11)/screenScale)
	yPos = windowTopLeft[1]+int((y+45)/screenScale)
	user32.SetCursorPos(xPos, yPos)
	
	user32.mouse_event(0x2,0,0,0,0) #クリックする
	time.sleep(wait)
	user32.mouse_event(0x4,0,0,0,0) #クリックを放す

def clickNearCenter():
	click(int((1280+10)/2*windowScale), int((720+10)/2*windowScale))

def clickOptionsButton(x,y):
	click(x,y+30*screenScale)

def move(x = -1,y = -1):
	xPos = windowTopLeft[0]+int((x+11)/screenScale)
	yPos = windowTopLeft[1]+int((y+45)/screenScale)
	user32.SetCursorPos(xPos, yPos)

def moveCenter():
	move(int(1280/2*windowScale), int(720/2*windowScale))

def keyboard(keycode):
	user32.keybd_event(keycode,0,0,0)
	time.sleep(0.1)
	user32.keybd_event(keycode,0,0x2,0)

def proc(hwnd,ar):
	title = winxpgui.GetWindowText(hwnd)
	if ar[0] in title:
		#print hwnd, title
		ar[1].append(hwnd)
	return 1

def getid(title,n = 0):
	hwnds = []
	winxpgui.EnumWindows(proc,[title,hwnds])
	return hwnds[n]
